#ifndef _KGR_PATCH_BSC1197597_H
#define _KGR_PATCH_BSC1197597_H

#if IS_ENABLED(CONFIG_SND_PCM)

#include <linux/mutex.h>
#include <linux/spinlock.h>
#include <sound/pcm.h>

/* Protected by module_mutex. */
struct kgr_bsc1197597_shared_state {
	unsigned long refcount;
	struct mutex snd_pcm_runtime_buffer_mutex;
	spinlock_t spin;
};

struct action_ops;
struct snd_pcm_substream;

int kgrp_snd_pcm_action_nonatomic(struct action_ops *ops,
				    struct snd_pcm_substream *substream,
				    int state);

struct snd_pcm_hw_params;

int kgrp_snd_pcm_hw_params(struct snd_pcm_substream *substream,
			     struct snd_pcm_hw_params *params);

struct file;

int kgrp_snd_pcm_common_ioctl1(struct file *file,
				 struct snd_pcm_substream *substream,
				 unsigned int cmd, void __user *arg);

struct snd_info_entry;
struct snd_info_buffer;

void kgrp_snd_pcm_lib_preallocate_proc_write(struct snd_info_entry *entry,
					       struct snd_info_buffer *buffer);

typedef int (*transfer_f)(struct snd_pcm_substream *substream, unsigned int hwoff,
			  unsigned long data, unsigned int off,
			  snd_pcm_uframes_t size);

snd_pcm_sframes_t kgrp_snd_pcm_lib_write1(struct snd_pcm_substream *substream,
					    unsigned long data,
					    snd_pcm_uframes_t size,
					    int nonblock,
					    transfer_f transfer);

snd_pcm_sframes_t kgrp_snd_pcm_lib_read1(struct snd_pcm_substream *substream,
					   unsigned long data,
					   snd_pcm_uframes_t size,
					   int nonblock,
					   transfer_f transfer);

int bsc1197597_pcm_native_init(void);
void bsc1197597_pcm_native_cleanup(void);

int bsc1197597_pcm_memory_init(void);
void bsc1197597_pcm_memory_cleanup(void);

int bsc1197597_pcm_lib_init(void);
void bsc1197597_pcm_lib_cleanup(void);

int *kgrp_runtime_get_buffer_accessing(struct snd_pcm_runtime *runtime);
void kgrp_runtime_free_buffer_accessing(struct snd_pcm_runtime *runtime);

int kgr_patch_bsc1197597_init(void);
void kgr_patch_bsc1197597_cleanup(void);

#define KGR_PATCH_BSC1197597_FUNCS					\
	KGR_PATCH_OBJ(snd_pcm_action_nonatomic,			\
		      kgrp_snd_pcm_action_nonatomic, "snd_pcm"),	\
	KGR_PATCH_OBJ(snd_pcm_hw_params, kgrp_snd_pcm_hw_params,	\
		      "snd_pcm"),					\
	KGR_PATCH_OBJ(snd_pcm_common_ioctl1,				\
		      kgrp_snd_pcm_common_ioctl1, "snd_pcm"),		\
	KGR_PATCH_OBJ(snd_pcm_lib_write1, kgrp_snd_pcm_lib_write1,	\
		      "snd_pcm"),					\
	KGR_PATCH_OBJ(snd_pcm_lib_read1, kgrp_snd_pcm_lib_read1,	\
		      "snd_pcm"),					\
	KGR_PATCH_OBJ(snd_pcm_lib_preallocate_proc_write,		\
		      kgrp_snd_pcm_lib_preallocate_proc_write,		\
		      "snd_pcm"),					\

#else /* !IS_ENABLED(CONFIG_SND_PCM) */

static inline int kgr_patch_bsc1197597_init(void) { return 0; }
static inline void kgr_patch_bsc1197597_cleanup(void) {}

#define KGR_PATCH_BSC1197597_FUNCS

#endif /* IS_ENABLED(CONFIG_SND_PCM) */

#endif /* _KGR_PATCH_BSC1197597_H */
